<!DOCTYPE html>
<html>

<head>
   <style>
      #metawidget {
         border: 1px solid #cccccc;
         width: 800px;
         border-radius: 10px;
         padding: 10px;
         margin: 50px auto;
         display: flex;
         flex-direction: column;
         justify-content: center;
      }

      #metawidget button {
         display: block;
         margin: 10px auto 0px;
      }
   </style>
   <!--using external CDN includes packages -->
   <script src="http://metawidget.org/js/4.2/metawidget-core.min.js"" type=" text/javascript"></script>
   <link rel="stylesheet" href="http://code.jquery.com/ui/1.9.2/themes/base/jquery-ui.css" />
   <script src="http://code.jquery.com/jquery-1.8.3.js"></script>
   <script src="http://code.jquery.com/ui/1.9.2/jquery-ui.js"></script>
   <script src="http://metawidget.org/js/4.2/metawidget-jqueryui.min.js" type="text/javascript"></script>
   <script src="https://unpkg.com/axios/dist/axios.min.js"> </script>
   <script type="text/javascript">

      var index_child = 1;
      var person = {
         name: "",
         age: 0,
         employer: "",
         department: "",
      };

   </script>
</head>

<body>
   <div id="metawidget">
      <button onclick="save()">Save</button>
      <button onclick="add_child()">Add Child</button>
   </div>
   <button onclick="fetch_data()">view data</button>
   <script type="text/javascript">
      var mw = new metawidget.Metawidget(document.getElementById('metawidget'), {
         inspector: new metawidget.inspector.CompositeInspector([new metawidget.inspector.PropertyTypeInspector(),
         function (toInspect, type, names) {
            return {
               properties: {
                  name: {
                     type: 'string',
                     required: true
                  },
                  age: {
                     type: 'number',
                     required: true
                  },
                  employer: {
                     type: "string",
                     // section: ""
                  },
                  department: {
                     type: "string"
                  },
                  address: {
                     type: "string",
                     section: 'Family'
                  },
               }
            };
         }]),
         layout: new metawidget.jqueryui.layout.TabLayoutDecorator(
            new metawidget.layout.TableLayout({ numberOfColumns: 2 }))
      });
      mw.toInspect = person;
      mw.buildWidgets();


      function save() {
         // save metawidget data 
         mw.getWidgetProcessor(
            function (widgetProcessor) {
               return widgetProcessor instanceof metawidget.widgetprocessor.SimpleBindingProcessor;
            }
         ).save(mw);
         // call api to insert to DynamoDB
         axios.post('/api/submit', person)
            .then(response => {
               console.log(response);
               if (response.data.success == true) {
                  alert("save successfully");
               }
               else {
                  alert("Error plz try again");
               }
            })
            .catch(error => {
               alert(error)
            });
      }

      function add_child() {
         // update person change 
         var processor = mw.getWidgetProcessor(
            function (widgetProcessor) {
               return widgetProcessor instanceof metawidget.widgetprocessor.SimpleBindingProcessor;
            }
         ).save(mw);
         console.log(person);
         // add new child
         person['child' + index_child] = " ";
         index_child++;
         mw.buildWidgets();
      }

      function fetch_data() {
         console.log("fetch pressed");
         axios.get('/api/fetch').then(res => {
            alert(JSON.stringify(res.data));
         }).catch(error => {
            console.log(error)
            alert(error, res.error)
         })
      }
   </script>
</body>

</html>